libaaruformat 1.0 Aaru Data Preservation Suite - Format Library

Loading...
Searching...
No Matches
aaru_options Struct Reference

Parsed user-specified tunables controlling compression, deduplication, hashing and DDT geometry. More...

`#include <aaruformat/structs/options.h>`

## Data Fields
bool | compress
| Enable adaptive compression (LZMA for data blocks, FLAC for audio). Default: true.
bool | deduplicate
| Storage dedup flag (DDT always exists).
uint32_t | dictionary
| LZMA dictionary size in bytes (>= 4096 recommended). Default: 33554432 (32 MiB).
int8_t | table_shift
| DDT table shift (multi-level fan-out exponent). Default: heuristically calculated.
uint8_t | data_shift
| Global data shift: low bits encode sector offset inside a block (2^data_shift span).
uint8_t | block_alignment
| log2 underlying block alignment (2^n bytes). Default: 9 (512 bytes).
bool | md5
| Generate MD5 checksum (ChecksumAlgorithm::Md5) when finalizing image.
bool | sha1
| Generate SHA-1 checksum (ChecksumAlgorithm::Sha1) when finalizing image.
bool | sha256
| Generate SHA-256 checksum (ChecksumAlgorithm::Sha256) when finalizing image.
bool | blake3
| Generate BLAKE3 checksum if supported (not stored if algorithm unavailable).
bool | spamsum
| Generate SpamSum fuzzy hash (ChecksumAlgorithm::SpamSum) if enabled.

## Detailed Description

Parsed user-specified tunables controlling compression, deduplication, hashing and DDT geometry.

All shifts are exponents of two.

Definition at line 216 of file options.h.

## Field Documentation

## ◆ blake3

bool aaru_options::blake3

Generate BLAKE3 checksum if supported (not stored if algorithm unavailable).

Definition at line 228 of file options.h.

Referenced by aaruf_create(), and parse_options().

## ◆ block_alignment

uint8_t aaru_options::block_alignment

log2 underlying block alignment (2^n bytes). Default: 9 (512 bytes).

Definition at line 224 of file options.h.

Referenced by aaruf_create(), and parse_options().

## ◆ compress

bool aaru_options::compress

Enable adaptive compression (LZMA for data blocks, FLAC for audio). Default: true.

Definition at line 218 of file options.h.

Referenced by aaruf_create(), aaruf_open(), and parse_options().

## ◆ data_shift

uint8_t aaru_options::data_shift

Global data shift: low bits encode sector offset inside a block (2^data_shift span).

Definition at line 223 of file options.h.

Referenced by aaruf_create(), and parse_options().

## ◆ deduplicate

bool aaru_options::deduplicate

Storage dedup flag (DDT always exists).

true=share identical sector content, false=store each instance.

Definition at line 219 of file options.h.

Referenced by aaruf_create(), aaruf_open(), and parse_options().

## ◆ dictionary

uint32_t aaru_options::dictionary

LZMA dictionary size in bytes (>= 4096 recommended). Default: 33554432 (32 MiB).

Definition at line 221 of file options.h.

Referenced by aaruf_create(), aaruf_open(), and parse_options().

## ◆ md5

bool aaru_options::md5

Generate MD5 checksum (ChecksumAlgorithm::Md5) when finalizing image.

Definition at line 225 of file options.h.

Referenced by aaruf_create(), and parse_options().

## ◆ sha1

bool aaru_options::sha1

Generate SHA-1 checksum (ChecksumAlgorithm::Sha1) when finalizing image.

Definition at line 226 of file options.h.

Referenced by aaruf_create(), and parse_options().

## ◆ sha256

bool aaru_options::sha256

Generate SHA-256 checksum (ChecksumAlgorithm::Sha256) when finalizing image.

Definition at line 227 of file options.h.

Referenced by aaruf_create(), and parse_options().

## ◆ spamsum

bool aaru_options::spamsum

Generate SpamSum fuzzy hash (ChecksumAlgorithm::SpamSum) if enabled.

Definition at line 229 of file options.h.

Referenced by aaruf_create(), and parse_options().

## ◆ table_shift

int8_t aaru_options::table_shift

DDT table shift (multi-level fan-out exponent). Default: heuristically calculated.

Definition at line 222 of file options.h.

Referenced by aaruf_create(), and parse_options().

The documentation for this struct was generated from the following file:

- include/aaruformat/structs/options.h